from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import RegularNGon2 as Shape


class RegularNGon(FoldedComponent):
  def define(self):
    self.addParameter("n", 5, valueType="int", minValue=3)
    self.addParameter("radius", 25, paramType="length")

    self.addEdgeInterface("e0", "e0", "radius")
    self.addFaceInterface("face", "r")

  def assemble(self):
    n = self.getParameter("n")
    l = self.getParameter("radius")

    self.addFace(Shape("r", n, l))

    for i in range(n):
        try:
            self.setEdgeInterface("e%d" % i, "e%d" % i, "radius")
        except KeyError:
            self.addEdgeInterface("e%d"%i, "e%d" % i, "radius")

if __name__ == "__main__":
    RegularNGon.test()
